
void _efl_canvas_animation_final_state_keep_set(Eo *obj, Efl_Canvas_Animation_Data *pd, Eina_Bool keep);


static Eina_Error
__eolian_efl_canvas_animation_final_state_keep_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_animation_final_state_keep_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_animation_final_state_keep_set, EFL_FUNC_CALL(keep), Eina_Bool keep);

Eina_Bool _efl_canvas_animation_final_state_keep_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


static Eina_Value
__eolian_efl_canvas_animation_final_state_keep_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_animation_final_state_keep_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_animation_final_state_keep_get, Eina_Bool, 0);

void _efl_canvas_animation_duration_set(Eo *obj, Efl_Canvas_Animation_Data *pd, double sec);


static Eina_Error
__eolian_efl_canvas_animation_duration_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_animation_duration_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_animation_duration_set, EFL_FUNC_CALL(sec), double sec);

double _efl_canvas_animation_duration_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


static Eina_Value
__eolian_efl_canvas_animation_duration_get_reflect(const Eo *obj)
{
   double val = efl_animation_duration_get(obj);
   return eina_value_double_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_animation_duration_get, double, 0);

void _efl_canvas_animation_repeat_mode_set(Eo *obj, Efl_Canvas_Animation_Data *pd, Efl_Canvas_Animation_Repeat_Mode mode);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_animation_repeat_mode_set, EFL_FUNC_CALL(mode), Efl_Canvas_Animation_Repeat_Mode mode);

Efl_Canvas_Animation_Repeat_Mode _efl_canvas_animation_repeat_mode_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_animation_repeat_mode_get, Efl_Canvas_Animation_Repeat_Mode, 0 /* Efl.Canvas.Animation_Repeat_Mode.restart */);

void _efl_canvas_animation_play_count_set(Eo *obj, Efl_Canvas_Animation_Data *pd, int count);


static Eina_Error
__eolian_efl_canvas_animation_play_count_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_animation_play_count_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_animation_play_count_set, EFL_FUNC_CALL(count), int count);

int _efl_canvas_animation_play_count_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


static Eina_Value
__eolian_efl_canvas_animation_play_count_get_reflect(const Eo *obj)
{
   int val = efl_animation_play_count_get(obj);
   return eina_value_int_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_animation_play_count_get, int, 1);

void _efl_canvas_animation_start_delay_set(Eo *obj, Efl_Canvas_Animation_Data *pd, double sec);


static Eina_Error
__eolian_efl_canvas_animation_start_delay_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_animation_start_delay_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_animation_start_delay_set, EFL_FUNC_CALL(sec), double sec);

double _efl_canvas_animation_start_delay_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


static Eina_Value
__eolian_efl_canvas_animation_start_delay_get_reflect(const Eo *obj)
{
   double val = efl_animation_start_delay_get(obj);
   return eina_value_double_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_animation_start_delay_get, double, 0);

void _efl_canvas_animation_interpolator_set(Eo *obj, Efl_Canvas_Animation_Data *pd, Efl_Interpolator *interpolator);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_animation_interpolator_set, EFL_FUNC_CALL(interpolator), Efl_Interpolator *interpolator);

Efl_Interpolator *_efl_canvas_animation_interpolator_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_animation_interpolator_get, Efl_Interpolator *, NULL);

double _efl_canvas_animation_animation_apply(Eo *obj, Efl_Canvas_Animation_Data *pd, double progress, Efl_Canvas_Object *target);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV(efl_animation_apply, double, 0, EFL_FUNC_CALL(progress, target), double progress, Efl_Canvas_Object *target);

void _efl_canvas_animation_default_duration_set(double animation_time);

EVAS_API EVAS_API_WEAK void efl_animation_default_duration_set(double animation_time)
{
   const Efl_Class *klass = efl_canvas_animation_class_get();
   EINA_SAFETY_ON_NULL_RETURN(klass);
   _efl_canvas_animation_default_duration_set(animation_time);
}

double _efl_canvas_animation_default_duration_get(void);

EVAS_API EVAS_API_WEAK double efl_animation_default_duration_get(void)
{
   const Efl_Class *klass = efl_canvas_animation_class_get();
   EINA_SAFETY_ON_NULL_RETURN_VAL(klass,0);
   return _efl_canvas_animation_default_duration_get();
}

Efl_Object *_efl_canvas_animation_efl_object_constructor(Eo *obj, Efl_Canvas_Animation_Data *pd);


double _efl_canvas_animation_efl_playable_length_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


Eina_Bool _efl_canvas_animation_efl_playable_seekable_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


Eina_Bool _efl_canvas_animation_efl_playable_playable_get(const Eo *obj, Efl_Canvas_Animation_Data *pd);


static Eina_Bool
_efl_canvas_animation_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_ANIMATION_EXTRA_OPS
#define EFL_CANVAS_ANIMATION_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_animation_final_state_keep_set, _efl_canvas_animation_final_state_keep_set),
      EFL_OBJECT_OP_FUNC(efl_animation_final_state_keep_get, _efl_canvas_animation_final_state_keep_get),
      EFL_OBJECT_OP_FUNC(efl_animation_duration_set, _efl_canvas_animation_duration_set),
      EFL_OBJECT_OP_FUNC(efl_animation_duration_get, _efl_canvas_animation_duration_get),
      EFL_OBJECT_OP_FUNC(efl_animation_repeat_mode_set, _efl_canvas_animation_repeat_mode_set),
      EFL_OBJECT_OP_FUNC(efl_animation_repeat_mode_get, _efl_canvas_animation_repeat_mode_get),
      EFL_OBJECT_OP_FUNC(efl_animation_play_count_set, _efl_canvas_animation_play_count_set),
      EFL_OBJECT_OP_FUNC(efl_animation_play_count_get, _efl_canvas_animation_play_count_get),
      EFL_OBJECT_OP_FUNC(efl_animation_start_delay_set, _efl_canvas_animation_start_delay_set),
      EFL_OBJECT_OP_FUNC(efl_animation_start_delay_get, _efl_canvas_animation_start_delay_get),
      EFL_OBJECT_OP_FUNC(efl_animation_interpolator_set, _efl_canvas_animation_interpolator_set),
      EFL_OBJECT_OP_FUNC(efl_animation_interpolator_get, _efl_canvas_animation_interpolator_get),
      EFL_OBJECT_OP_FUNC(efl_animation_apply, _efl_canvas_animation_animation_apply),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_canvas_animation_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_playable_length_get, _efl_canvas_animation_efl_playable_length_get),
      EFL_OBJECT_OP_FUNC(efl_playable_seekable_get, _efl_canvas_animation_efl_playable_seekable_get),
      EFL_OBJECT_OP_FUNC(efl_playable_get, _efl_canvas_animation_efl_playable_playable_get),
      EFL_CANVAS_ANIMATION_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"final_state_keep", __eolian_efl_canvas_animation_final_state_keep_set_reflect, __eolian_efl_canvas_animation_final_state_keep_get_reflect},
      {"duration", __eolian_efl_canvas_animation_duration_set_reflect, __eolian_efl_canvas_animation_duration_get_reflect},
      {"play_count", __eolian_efl_canvas_animation_play_count_set_reflect, __eolian_efl_canvas_animation_play_count_get_reflect},
      {"start_delay", __eolian_efl_canvas_animation_start_delay_set_reflect, __eolian_efl_canvas_animation_start_delay_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_animation_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Animation",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Canvas_Animation_Data),
   _efl_canvas_animation_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_animation_class_get, &_efl_canvas_animation_class_desc, EFL_OBJECT_CLASS, EFL_PLAYABLE_INTERFACE, NULL);
